#!/usr/bin/env perl

use strict;
use warnings;

use Data::Dumper qw(Dumper);

use XML::Compile::WSDL11 ();
use XML::Compile::SOAP11 ();
use XML::Compile::Transport::SOAPHTTP ();
use XML::Compile::SOAP;

my %calls;

my $wsdl = XML::Compile::WSDL11->new('FooService.wsdl');
$wsdl->compileCalls();

try_request({
    Header => {
        Prop1 => 'a',
        Prop2 => 'b',
    },
    Body => {
        Bar => '1234',
    },
});
try_request({
	Body => {
	    Header => {
	        Prop1 => 'a',
	        Prop2 => 'b',
	    },
	    Body => {
	        Bar => '1234',
	    },
	}
});
try_request({
	Body => {
		FooRequest => {
		    Header => {
		        Prop1 => 'a',
		        Prop2 => 'b',
		    },
		    Body => {
		        Bar => '1234',
		    },
		}
	}
});


sub try_request {
	my ($msg_ref) = @_;
	my ($res, $trace) = $wsdl->call('Operation_FooRequest', %$msg_ref);

	#warn "DEBUG:  Result: " . Dumper($res);
	#warn "DEBUG:  trace:  " . Dumper($trace);
	warn "DEBUG:  request input:  " . Dumper($msg_ref);
	warn "DEBUG:  request:  " . ${$trace->{http_response}{_request}{_content}};
	warn "\n"
}
